@echo off
if [%1]==[?] goto Syntax
if [%1]==[/?] goto Syntax
if [%1]==[-?] goto Syntax
if [%1]==[--h] goto Syntax
if [%2]==[] goto fail
if [%2]==[%1] goto SourceEqualsDestination
if [%3]==[\] %0 %1 %2 \.
if [%3]==[] %0 %1 %2 \.
rem
rem Is the first parameter the diskdrive/path for the gavenger self extractor?
rem Verify the first parameter.
rem
if not exist %1gainst.exe goto BadSource
rem
rem Is the second parameter a legal disk drive?  No verification at this point.
rem
%2
rem
rem Is the third parameter a legal subdirectory of the Target drive?  Verify
rem second and third parameters.  Let's hope we don't have write failure
rem problems.
rem
if exist %3 goto DirFileError
if not exist %2%3\nul goto NoSuchDir
if not exist %3\nul goto TargetPathError
:GoodDir
cd %3 >nul
if exist $_#DEL$.$ME echo y | del %2%3\$_#DEL$.$ME > nul
if exist GAVENGER\nul goto Upgrade
cls
echo ķ
echo  GALACTIC AVENGER INSTALLATION 
echo Ľ
echo Making Directories.
mkdir GAVENGER >nul
:DirMade
cd GAVENGER
:BaseDir
echo LHA's SFX 2.13L (c) Yoshi, 1991
echo Please wait while GALACTIC AVENGER melts to %2%3\GAVENGER
%1gainst.exe >nul
if exist %1old.top copy %1old.top gavenger.top > nul
if not exist %1old.top goto ShortSkip
echo y | del %1old.top > nul
:ShortSkip
if not exist PMINFO.EXE goto NotAllCopied
if exist %1winstall.com %1winstall.com %2%3\GAVENGER
pause
cls
echo ķ
echo  GALACTIC AVENGER INSTALLATION COMPLETE 
echo Ľ
echo - Galactic Avenger has been installed to %2%3\GAVENGER
echo - Remember the directory given above to run Galactic Avenger in the future
echo - If no errors were reported simply type "gavenger" then enter to start
goto end
rem
rem Need to switch to drive A: first
rem
:SwADrive
if not exist a:gainst.exe goto TrulyBadSource
A:
%0 A: %2 %3
rem
rem Need to switch to drive B: first
rem
:SwBDrive
if not exist b:gainst.exe goto TrulyBadSource
B:
%0 B: %2 %3
rem
rem The user has input a bad source drive?
rem
:BadSource
for %%f in (install.bat Install.bat INSTALL.BAT install Install INSTALL) do if a:%%f==%0 goto SwADrive
for %%f in (install.bat Install.bat INSTALL.BAT install Install INSTALL) do if A:%%f==%0 goto SwADrive
for %%f in (install.bat Install.bat INSTALL.BAT install Install INSTALL) do if b:%%f==%0 goto SwBDrive
for %%f in (install.bat Install.bat INSTALL.BAT install Install INSTALL) do if B:%%f==%0 goto SwBDrive
:TrulyBadSource
cls
echo Ŀ
echo  Error: Failed to install Galactic Avenger. 
echo 
echo Unable to find installation data in the source drive:
echo.
echo     %1
echo.
echo Ensure that the installation diskette is in the source drive and that
echo this is your current default drive.
if [%1]==[A:] echo A typical problem is in confusing the A: and B: drives
if [%1]==[a:] echo A typical problem is in confusing the A: and B: drives
if [%1]==[B:] echo A typical problem is in confusing the A: and B: drives
if [%1]==[b:] echo A typical problem is in confusing the A: and B: drives
goto MustReinstall
rem
rem See if switching to a: helps
rem
:TryADrive
a:
if exist ui.exe goto UserInterface
goto Syntax
rem
rem See if switching to b: helps
rem
:TryBDrive
b:
if exist ui.exe goto UserInterface
goto Syntax
rem
rem General parameter failure
rem
:fail
if exist ui.exe goto UserInterface
if exist %1ui.exe goto UserInterface2
for %%f in (install.bat Install.bat INSTALL.BAT install Install INSTALL) do if a:%%f==%0 goto TryADrive
for %%f in (install.bat Install.bat INSTALL.BAT install Install INSTALL) do if A:%%f==%0 goto TryADrive
for %%f in (install.bat Install.bat INSTALL.BAT install Install INSTALL) do if b:%%f==%0 goto TryBDrive
for %%f in (install.bat Install.bat INSTALL.BAT install Install INSTALL) do if B:%%f==%0 goto TryBDrive
:Syntax
echo	Ŀ
echo	 GALACTIC AVENGER INSTALLATION 				    
echo	-------------------------------------------------------------------
echo	 SYNTAX:   INSTALL  source-drive  target-drive  [sub-directory]    
echo									    
echo	 For ex., "INSTALL A: C: \GAMES" will install Galactic Avenger to  
echo	 C:\GAMES\GAVENGER from drive A: (where the installation diskette  
echo	 must be).							    
echo									    
echo	 NOTE:  The colons (":") must be present after drive letters, and  
echo	 the target drive and sub-directory must be separated by a space.  
echo	 For the subdirectory the leading "\" is optional, but there must  
echo	 not be a trailing one.  The installation diskette must be in the  
echo	 source-drive, and the drive door must be closed of course.	    
echo	
goto end
rem
rem Enter drives and directories from a user interface
rem
:UserInterface
ui.exe
goto end
:UserInterface2
%1ui.exe
goto end
rem
rem In the event that the target drive/sub-dir combination did not exist.
rem
:NoSuchDir
mkdir %3 > nul
echo . > %2%3\$_#DEL$.$ME
if exist %2%3\$_#DEL$.$ME goto GoodDir
rem
rem In the event that the target drive/sub-dir combination cannot be made.
rem or if one of them individually is at fault
rem
rmdir %3 > nul
:TrickyDestinationParameters
cls
echo Ŀ
echo  Error: Failed to install Galactic Avenger. 
echo 
echo Unable to find the directory:
echo.
echo	 %3
echo.
echo on drive:
echo.
echo	 %2
echo.
goto MustReinstall
rem
rem In the event a version of Galactic Avenger was already installed.
rem
:Upgrade
echo Previous installation of Galactic Avenger detected
cd gavenger
echo Retaining high score file
copy gavenger.top %1old.top > nul
echo y | del *.* > nul
cd ..
cls
echo Ŀ
echo  Upgrading GALACTIC AVENGER 
echo 
if not exist %1old.top echo Warning: Unable to retain high scores.
goto DirMade
rem
rem Path is not consistent.  Likely you made a typo on the drive.  Could be a
rem network drive with unusual access restrictions.
rem
:TargetPathError
echo Ŀ
echo  Error: Failed to install Galactic Avenger. 
echo 
echo Either the drive specified:
echo.
echo	 %2
echo.
echo or the directory:
echo.
echo	 %3
echo.
echo Is not accessible as expected.  Check the drive syntax or else verify
echo that you are using a proper version of DOS.
goto MustReinstall
rem
rem Trying to make a directory when a file of the same name already exists.
rem
:DirFileError
echo Ŀ
echo  Error: Failed to install Galactic Avenger. 
echo 
echo Directory name cannot be the same as an existing filename.
goto MustReinstall
rem
rem Not all the files made it
rem
:NotAllCopied
echo Ŀ
echo  Error: Failed to install Galactic Avenger. 
echo 
echo Not all files were successfully installed on the destination drive.
echo There may not be enough disk space on your target drive for the complete
echo installation.  Refer to the %1READ.ME for system requirements.
goto end
rem
rem Source drive = Destiation drive.
rem
:SourceEqualsDestination
echo Ŀ
echo  Error: Failed to install Galactic Avenger. 
echo 
echo Invalid destination drive.  Galactic Avenger cannot be installed if
echo you specify the same drive for source and destination.
goto end
rem
rem Generic message informing the user that they have to try again.
rem
:MustReinstall
echo.
echo Galactic Avenger was NOT installed.  Reinstallation is neccessary.
:end
